import { ProxyLogManager } from '../../manager/index.js';
var LogAPI = /** @class */ (function () {
    function LogAPI(_a) {
        var proxyLogManager = _a.proxyLogManager;
        var _this = this;
        this.getLogManager = function () {
            return _this._proxyLogManager;
        };
        this._proxyLogManager = proxyLogManager;
    }
    LogAPI.getInstance = function () {
        if (!this._instance) {
            this._instance = new LogAPI({
                proxyLogManager: new ProxyLogManager(),
            });
        }
        return this._instance;
    };
    LogAPI.prototype.setGlobalLogManager = function (logManager) {
        this._proxyLogManager.setDelegate(logManager);
    };
    LogAPI.prototype.logException = function (error, handled, attributes, timestamp) {
        this.getLogManager().logException(error, handled, attributes, timestamp);
    };
    LogAPI.prototype.message = function (message, level, attributes, includeStacktrace) {
        this.getLogManager().message(message, level, attributes, includeStacktrace);
    };
    return LogAPI;
}());
export { LogAPI };
//# sourceMappingURL=LogAPI.js.map