import { ProxySpanSessionManager, } from '../../manager/index.js';
var SessionAPI = /** @class */ (function () {
    function SessionAPI(_a) {
        var proxySpanSessionManager = _a.proxySpanSessionManager;
        var _this = this;
        this.getSpanSessionManager = function () {
            return _this._proxySpanSessionManager;
        };
        this._proxySpanSessionManager = proxySpanSessionManager;
    }
    SessionAPI.getInstance = function () {
        if (!this._instance) {
            this._instance = new SessionAPI({
                proxySpanSessionManager: new ProxySpanSessionManager(),
            });
        }
        return this._instance;
    };
    SessionAPI.prototype.setGlobalSessionManager = function (sessionManager) {
        this._proxySpanSessionManager.setDelegate(sessionManager);
    };
    SessionAPI.prototype.addBreadcrumb = function (name) {
        this.getSpanSessionManager().addBreadcrumb(name);
    };
    SessionAPI.prototype.addProperty = function (key, value) {
        this.getSpanSessionManager().addProperty(key, value);
    };
    SessionAPI.prototype.endSessionSpan = function () {
        this.getSpanSessionManager().endSessionSpan();
    };
    SessionAPI.prototype.endSessionSpanInternal = function (reason) {
        this.getSpanSessionManager().endSessionSpanInternal(reason);
    };
    SessionAPI.prototype.getSessionId = function () {
        return this.getSpanSessionManager().getSessionId();
    };
    SessionAPI.prototype.getSessionSpan = function () {
        return this.getSpanSessionManager().getSessionSpan();
    };
    SessionAPI.prototype.getSessionStartTime = function () {
        return this.getSpanSessionManager().getSessionStartTime();
    };
    SessionAPI.prototype.startSessionSpan = function () {
        this.getSpanSessionManager().startSessionSpan();
    };
    return SessionAPI;
}());
export { SessionAPI };
//# sourceMappingURL=SessionAPI.js.map