import { ProxyTraceManager } from '../../manager/index.js';
var TraceAPI = /** @class */ (function () {
    function TraceAPI(_a) {
        var proxyTraceManager = _a.proxyTraceManager;
        var _this = this;
        this.getTraceManager = function () {
            return _this._proxyTraceManager;
        };
        this._proxyTraceManager = proxyTraceManager;
    }
    TraceAPI.getInstance = function () {
        if (!this._instance) {
            this._instance = new TraceAPI({
                proxyTraceManager: new ProxyTraceManager(),
            });
        }
        return this._instance;
    };
    TraceAPI.prototype.setGlobalTraceManager = function (traceManager) {
        this._proxyTraceManager.setDelegate(traceManager);
    };
    TraceAPI.prototype.startPerformanceSpan = function (name, options) {
        return this.getTraceManager().startPerformanceSpan(name, options);
    };
    return TraceAPI;
}());
export { TraceAPI };
//# sourceMappingURL=TraceAPI.js.map