import { ProxyUserManager } from '../../manager/index.js';
var UserAPI = /** @class */ (function () {
    function UserAPI(_a) {
        var proxyUserManager = _a.proxyUserManager;
        this._proxyUserManager = proxyUserManager;
    }
    UserAPI.getInstance = function () {
        if (!this._instance) {
            this._instance = new UserAPI({
                proxyUserManager: new ProxyUserManager(),
            });
        }
        return this._instance;
    };
    UserAPI.prototype.getUserManager = function () {
        return this._proxyUserManager;
    };
    UserAPI.prototype.setGlobalUserManager = function (userManager) {
        this._proxyUserManager.setDelegate(userManager);
    };
    UserAPI.prototype.clearUser = function () {
        this.getUserManager().clearUser();
    };
    UserAPI.prototype.getUser = function () {
        return this.getUserManager().getUser();
    };
    UserAPI.prototype.setUser = function (user) {
        this.getUserManager().setUser(user);
    };
    return UserAPI;
}());
export { UserAPI };
//# sourceMappingURL=UserAPI.js.map