import { createOtlpNetworkExportDelegate } from '@opentelemetry/otlp-exporter-base';
import { createFetchTransport, createRetryingTransport, } from '../transport/index.js';
// createOtlpBrowserFetchExportDelegate creates an export delegate that uses
// the Fetch API to send data to an OTLP receiver.
export var createOtlpBrowserFetchExportDelegate = function (config, serializer) {
    // createOtlpNetworkExportDelegate has an internal queue that handles
    // multiple requests going at the same time.
    return createOtlpNetworkExportDelegate(config, serializer, createRetryingTransport({
        transport: createFetchTransport(config),
    }));
};
//# sourceMappingURL=otlpBrowserFetchExportDelegate.js.map