var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { session } from '../../api-sessions/index.js';
import { log } from '../../api-logs/index.js';
import { OTelPerformanceManager } from '../../utils/index.js';
import { InstrumentationAbstract } from '../InstrumentationAbstract/index.js';
var EmbraceInstrumentationBase = /** @class */ (function (_super) {
    __extends(EmbraceInstrumentationBase, _super);
    function EmbraceInstrumentationBase(_a) {
        var instrumentationName = _a.instrumentationName, instrumentationVersion = _a.instrumentationVersion, config = _a.config, diag = _a.diag, perf = _a.perf;
        var _this = _super.call(this, instrumentationName, instrumentationVersion, config) || this;
        // optionally override the diag logger from the base class
        if (diag) {
            _this._diag = diag;
        }
        _this._perf = perf !== null && perf !== void 0 ? perf : new OTelPerformanceManager();
        _this._sessionManager = session.getSpanSessionManager();
        _this._logManager = log.getLogManager();
        return _this;
    }
    Object.defineProperty(EmbraceInstrumentationBase.prototype, "sessionManager", {
        /* Returns session provider */
        get: function () {
            return this._sessionManager;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(EmbraceInstrumentationBase.prototype, "logManager", {
        /* Returns session provider */
        get: function () {
            return this._logManager;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(EmbraceInstrumentationBase.prototype, "perf", {
        /* Returns the performance manager */
        get: function () {
            return this._perf;
        },
        enumerable: false,
        configurable: true
    });
    // no-op
    EmbraceInstrumentationBase.prototype.init = function () {
        return undefined;
    };
    return EmbraceInstrumentationBase;
}(InstrumentationAbstract));
export { EmbraceInstrumentationBase };
//# sourceMappingURL=EmbraceInstrumentationBase.js.map