var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { EmbraceInstrumentationBase } from '../../EmbraceInstrumentationBase/index.js';
var GlobalExceptionInstrumentation = /** @class */ (function (_super) {
    __extends(GlobalExceptionInstrumentation, _super);
    function GlobalExceptionInstrumentation(_a) {
        var _b = _a === void 0 ? {} : _a, diag = _b.diag, perf = _b.perf;
        var _this = _super.call(this, {
            instrumentationName: 'GlobalExceptionInstrumentation',
            instrumentationVersion: '1.0.0',
            diag: diag,
            perf: perf,
            config: {},
        }) || this;
        _this._onErrorHandler = function (event) {
            _this.logManager.logException(event.error, false, {}, _this.perf.epochMillisFromOriginOffset(event.timeStamp));
        };
        _this._onUnhandledRejectionHandler = function (event) {
            var error;
            if (event.reason && event.reason instanceof Error) {
                error = event.reason;
            }
            else {
                error = new Error(typeof event.reason === 'string'
                    ? event.reason
                    : 'Unhandled Rejected Promise');
                error.stack = '';
            }
            _this.logManager.logException(error, false, {}, _this.perf.epochMillisFromOriginOffset(event.timeStamp));
        };
        if (_this._config.enabled) {
            _this.enable();
        }
        return _this;
    }
    GlobalExceptionInstrumentation.prototype.disable = function () {
        window.removeEventListener('error', this._onErrorHandler);
        window.removeEventListener('unhandledrejection', this._onUnhandledRejectionHandler);
    };
    GlobalExceptionInstrumentation.prototype.enable = function () {
        window.addEventListener('error', this._onErrorHandler);
        window.addEventListener('unhandledrejection', this._onUnhandledRejectionHandler);
    };
    return GlobalExceptionInstrumentation;
}(EmbraceInstrumentationBase));
export { GlobalExceptionInstrumentation };
//# sourceMappingURL=GlobalExceptionInstrumentation.js.map