var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { EMB_TYPES, KEY_EMB_TYPE } from '../../../constants/index.js';
import { withErrorFallback } from '../../../utils/index.js';
import { ALL_WEB_VITALS, CORE_WEB_VITALS, EMB_WEB_VITALS_PREFIX, WEB_VITALS_ID_TO_LISTENER, } from './constants.js';
import { EmbraceInstrumentationBase } from '../../EmbraceInstrumentationBase/index.js';
var WebVitalsInstrumentation = /** @class */ (function (_super) {
    __extends(WebVitalsInstrumentation, _super);
    // instrumentation that adds an event to the session span for each web vital report
    function WebVitalsInstrumentation(_a) {
        var _b = _a === void 0 ? {} : _a, diag = _b.diag, perf = _b.perf, _c = _b.trackingLevel, trackingLevel = _c === void 0 ? 'core' : _c, _d = _b.listeners, listeners = _d === void 0 ? WEB_VITALS_ID_TO_LISTENER : _d;
        var _this = _super.call(this, {
            instrumentationName: 'WebVitalsInstrumentation',
            instrumentationVersion: '1.0.0',
            diag: diag,
            perf: perf,
            config: {},
        }) || this;
        _this._listeners = listeners;
        _this._metricsToTrack =
            trackingLevel === 'core' ? __spreadArray([], __read(CORE_WEB_VITALS), false) : __spreadArray([], __read(ALL_WEB_VITALS), false);
        if (_this._config.enabled) {
            _this.enable();
        }
        return _this;
    }
    WebVitalsInstrumentation.prototype.disable = function () {
        // do nothing.
        // https://github.com/GoogleChrome/web-vitals/issues/357#issuecomment-1593439036
    };
    WebVitalsInstrumentation.prototype.enable = function () {
        var _this = this;
        this._metricsToTrack.forEach(function (name) {
            var _a, _b;
            (_b = (_a = _this._listeners)[name]) === null || _b === void 0 ? void 0 : _b.call(_a, function (metric) {
                var _a;
                var currentSessionSpan = _this.sessionManager.getSessionSpan();
                if (!currentSessionSpan) {
                    return;
                }
                // first thing record the time when this cb was invoked
                var metricTime = _this._getTimeForMetric(metric);
                var attrs = (_a = {},
                    _a[KEY_EMB_TYPE] = EMB_TYPES.WebVital,
                    _a['emb.web_vital.navigation_type'] = metric.navigationType,
                    _a['emb.web_vital.name'] = metric.name,
                    _a['emb.web_vital.rating'] = metric.rating,
                    _a['emb.web_vital.id'] = metric.id,
                    _a['emb.web_vital.delta'] = metric.delta,
                    _a['emb.web_vital.value'] = metric.value,
                    _a);
                Object.entries(metric.attribution).forEach(function (_a) {
                    var _b = __read(_a, 2), key = _b[0], value = _b[1];
                    attrs["emb.web_vital.attribution.".concat(key)] =
                        typeof value === 'number'
                            ? value
                            : withErrorFallback(JSON.stringify, 'Error: unable to serialize the value as JSON. Likely a js circular structure.', false, _this._diag)(value);
                });
                currentSessionSpan.addEvent("".concat(EMB_WEB_VITALS_PREFIX, "-report-").concat(name), attrs, metricTime);
            });
        });
    };
    WebVitalsInstrumentation.prototype._getTimeForMetric = function (metric) {
        if (metric.name === 'CLS' && metric.attribution.largestShiftTime) {
            return this.perf.epochMillisFromOriginOffset(metric.attribution.largestShiftTime);
        }
        if (metric.name === 'INP' && metric.attribution.interactionTime) {
            return this.perf.epochMillisFromOriginOffset(metric.attribution.interactionTime);
        }
        return this.perf.getNowMillis();
    };
    return WebVitalsInstrumentation;
}(EmbraceInstrumentationBase));
export { WebVitalsInstrumentation };
//# sourceMappingURL=WebVitalsInstrumentation.js.map