import type { Attributes, AttributeValue } from '@opentelemetry/api';
import type { ReadableSpan } from '@opentelemetry/sdk-trace-web';
import { ATTR_HTTP_REQUEST_METHOD, SEMATTRS_HTTP_METHOD } from '@opentelemetry/semantic-conventions';
interface NetworkSpanAttributesDeprecated extends Attributes {
    [SEMATTRS_HTTP_METHOD]: AttributeValue;
}
interface NetworkSpanAttributesNewest extends Attributes {
    [ATTR_HTTP_REQUEST_METHOD]: AttributeValue;
}
type NetworkSpanAttributes = NetworkSpanAttributesNewest | NetworkSpanAttributesDeprecated;
interface NetworkSpan extends ReadableSpan {
    attributes: NetworkSpanAttributes;
}
export declare const isNetworkSpan: (span: ReadableSpan | NetworkSpan) => span is NetworkSpan;
export {};
//# sourceMappingURL=types.d.ts.map