var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { BindOnceFuture, ExportResultCode, internal, } from '@opentelemetry/core';
import { EMB_TYPES, KEY_EMB_TYPE } from '../../constants/index.js';
import { EmbraceProcessor } from '../EmbraceProcessor/index.js';
var isSessionSpan = function (span) {
    return span.attributes[KEY_EMB_TYPE] === EMB_TYPES.Session;
};
var EmbraceSessionBatchedSpanProcessor = /** @class */ (function (_super) {
    __extends(EmbraceSessionBatchedSpanProcessor, _super);
    function EmbraceSessionBatchedSpanProcessor(_a) {
        var _this = this;
        var exporter = _a.exporter, parentArgs = __rest(_a, ["exporter"]);
        _this = _super.call(this, __assign(__assign({}, parentArgs), { processorName: 'EmbraceSessionBatchedSpanProcessor' })) || this;
        _this._pendingSpans = [];
        _this._shutdown = function () {
            return _this._exporter.shutdown();
        };
        _this._exporter = exporter;
        _this._shutdownOnce = new BindOnceFuture(_this._shutdown, _this);
        return _this;
    }
    EmbraceSessionBatchedSpanProcessor.prototype.forceFlush = function () {
        this.diag.debug('forceFlush called for EmbraceSessionBatchedSpanProcessor. This is a no op');
        return Promise.resolve(undefined);
    };
    EmbraceSessionBatchedSpanProcessor.prototype.onEnd = function (span) {
        var _this = this;
        if (this._shutdownOnce.isCalled) {
            this.diag.debug('span ended after processor shutdown. Ignoring span.');
            return;
        }
        if (!isSessionSpan(span)) {
            this.diag.debug('non-session span ended. Adding to pending spans queue.');
            this._pendingSpans.push(span);
        }
        else {
            this.diag.debug('session span ended. Exporting all pending spans.');
            internal
                ._export(this._exporter, __spreadArray([span], __read(this._pendingSpans), false))
                .then(function (result) {
                var _a;
                if (result.code === ExportResultCode.FAILED) {
                    _this.diag.error("spans failed to export: ".concat(((_a = result.error) === null || _a === void 0 ? void 0 : _a.message) || 'unknown error'));
                }
            })
                // Seems like everything related to the export logic does a good job of catching and only ever resolving with
                // an ExportResult even on failure: https://github.com/open-telemetry/opentelemetry-js/blob/cf6dffeebcf72c42b2cb4d2bf2db720369b53081/packages/opentelemetry-core/src/internal/exporter.ts#L37
                // Keep this block just in case that assumption changes in a future version
                .catch(function (reason) {
                var msg = 'unknown error';
                if (reason && reason instanceof Error) {
                    msg = reason.message;
                }
                else if (typeof reason === 'string') {
                    msg = reason;
                }
                _this.diag.error("spans failed to export: ".concat(msg));
            });
            this._pendingSpans = [];
        }
    };
    EmbraceSessionBatchedSpanProcessor.prototype.onStart = function () {
        // do nothing.
    };
    EmbraceSessionBatchedSpanProcessor.prototype.shutdown = function () {
        return this._shutdownOnce.call();
    };
    return EmbraceSessionBatchedSpanProcessor;
}(EmbraceProcessor));
export { EmbraceSessionBatchedSpanProcessor };
//# sourceMappingURL=EmbraceSessionBatchedSpanProcessor.js.map