var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { diag, DiagConsoleLogger, DiagLogLevel } from '@opentelemetry/api';
import { logs } from '@opentelemetry/api-logs';
import { registerInstrumentations } from '@opentelemetry/instrumentation';
import { Resource } from '@opentelemetry/resources';
import { BatchLogRecordProcessor, LoggerProvider, } from '@opentelemetry/sdk-logs';
import { BatchSpanProcessor, WebTracerProvider, } from '@opentelemetry/sdk-trace-web';
import { session } from '../api-sessions/index.js';
import { KEY_ENDUSER_PSEUDO_ID, user } from '../api-users/index.js';
import { EmbraceLogExporter, EmbraceTraceExporter, } from '../exporters/index.js';
import { EmbraceLogManager, EmbraceSpanSessionManager, EmbraceTraceManager, EmbraceUserManager, } from '../managers/index.js';
import { EmbraceNetworkSpanProcessor, EmbraceSessionBatchedSpanProcessor, EmbTypeLogRecordProcessor, IdentifiableSessionLogRecordProcessor, } from '../processors/index.js';
import { getWebSDKResource } from '../resources/index.js';
import { isValidAppID } from './utils.js';
import { setupDefaultInstrumentations } from './setupDefaultInstrumentations.js';
import { createSessionSpanProcessor } from '@opentelemetry/web-common';
import { log } from '../api-logs/index.js';
import { trace } from '../api-traces/index.js';
import { registry } from './registry.js';
export var initSDK = function (_a) {
    var _b;
    var _c = _a === void 0 ? { appID: '' } : _a, appID = _c.appID, appVersion = _c.appVersion, _d = _c.resource, resource = _d === void 0 ? Resource.empty() : _d, _e = _c.spanExporters, spanExporters = _e === void 0 ? [] : _e, _f = _c.logExporters, logExporters = _f === void 0 ? [] : _f, _g = _c.spanProcessors, spanProcessors = _g === void 0 ? [] : _g, _h = _c.propagator, propagator = _h === void 0 ? null : _h, defaultInstrumentationConfig = _c.defaultInstrumentationConfig, _j = _c.instrumentations, instrumentations = _j === void 0 ? [] : _j, _k = _c.contextManager, contextManager = _k === void 0 ? null : _k, _l = _c.logProcessors, logProcessors = _l === void 0 ? [] : _l, _m = _c.logLevel, logLevel = _m === void 0 ? DiagLogLevel.ERROR : _m, _o = _c.diagLogger, diagLogger = _o === void 0 ? diag.createComponentLogger({
        namespace: 'embrace-sdk',
    }) : _o;
    try {
        var existingSDK = registry.registered();
        if (existingSDK !== null) {
            diagLogger.warn('SDK has already been successfully initialized, skipping this invocation of initSDK');
            return existingSDK;
        }
        diag.setLogger(new DiagConsoleLogger(), {
            logLevel: logLevel,
        });
        var resourceWithWebSDKAttributes = resource.merge(getWebSDKResource(appVersion));
        var sendingToEmbrace = !!appID && isValidAppID(appID);
        if (!sendingToEmbrace && !logExporters.length && !spanExporters.length) {
            throw new Error('when the embrace appID is omitted then at least one logExporter or spanExporter must be set');
        }
        var userManager = setupUser();
        var enduserPseudoID = (_b = userManager.getUser()) === null || _b === void 0 ? void 0 : _b[KEY_ENDUSER_PSEUDO_ID];
        if (sendingToEmbrace && !enduserPseudoID) {
            throw new Error('userID is required when using Embrace exporter');
        }
        var spanSessionManager = setupSession();
        var tracerProvider_1 = setupTraces({
            sendingToEmbrace: sendingToEmbrace,
            appID: appID,
            enduserPseudoID: enduserPseudoID,
            resource: resourceWithWebSDKAttributes,
            spanSessionManager: spanSessionManager,
            spanExporters: spanExporters,
            spanProcessors: spanProcessors,
            propagator: propagator,
            contextManager: contextManager,
        });
        var loggerProvider_1 = setupLogs({
            sendingToEmbrace: sendingToEmbrace,
            appID: appID,
            enduserPseudoID: enduserPseudoID,
            resource: resourceWithWebSDKAttributes,
            logExporters: logExporters,
            logProcessors: logProcessors,
            spanSessionManager: spanSessionManager,
        });
        // NOTE: we require setupInstrumentation to run the last, after setupLogs and setupTraces. This is how OTel works wrt
        // the dependencies between instrumentations and global providers. We need the providers for tracers, and logs to be
        // setup before we enable instrumentations.
        registerInstrumentations({
            instrumentations: __spreadArray(__spreadArray([], __read(instrumentations), false), [
                setupDefaultInstrumentations(defaultInstrumentationConfig),
            ], false),
        });
        diagLogger.info('successfully initialized the SDK');
        var sdkControl = {
            flush: function () { return __awaiter(void 0, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, tracerProvider_1.forceFlush()];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, loggerProvider_1.forceFlush()];
                        case 2:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); },
        };
        registry.register(sdkControl);
        return sdkControl;
    }
    catch (e) {
        var message = e instanceof Error ? e.message : 'Unknown error.';
        diagLogger.error("failed to initialize the SDK: ".concat(message));
        return false;
    }
};
var setupUser = function () {
    var embraceUserManager = new EmbraceUserManager();
    user.setGlobalUserManager(embraceUserManager);
    return embraceUserManager;
};
var setupSession = function () {
    var embraceSpanSessionManager = new EmbraceSpanSessionManager();
    session.setGlobalSessionManager(embraceSpanSessionManager);
    return embraceSpanSessionManager;
};
var setupTraces = function (_a) {
    var sendingToEmbrace = _a.sendingToEmbrace, appID = _a.appID, enduserPseudoID = _a.enduserPseudoID, resource = _a.resource, spanSessionManager = _a.spanSessionManager, spanExporters = _a.spanExporters, _b = _a.spanProcessors, spanProcessors = _b === void 0 ? [] : _b, _c = _a.propagator, propagator = _c === void 0 ? null : _c, _d = _a.contextManager, contextManager = _d === void 0 ? null : _d;
    var embraceTraceManager = new EmbraceTraceManager();
    trace.setGlobalTraceManager(embraceTraceManager);
    var finalSpanProcessors = __spreadArray(__spreadArray([], __read(spanProcessors), false), [
        createSessionSpanProcessor(spanSessionManager),
        new EmbraceNetworkSpanProcessor(),
    ], false);
    spanExporters === null || spanExporters === void 0 ? void 0 : spanExporters.forEach(function (exporter) {
        finalSpanProcessors.push(new BatchSpanProcessor(exporter));
    });
    if (sendingToEmbrace && appID && enduserPseudoID) {
        finalSpanProcessors.push(new EmbraceSessionBatchedSpanProcessor({
            exporter: new EmbraceTraceExporter({
                appID: appID,
                userID: enduserPseudoID,
            }),
        }));
    }
    var tracerProvider = new WebTracerProvider({
        resource: resource,
        spanProcessors: finalSpanProcessors,
    });
    tracerProvider.register({
        contextManager: contextManager,
        propagator: propagator,
    });
    return tracerProvider;
};
var setupLogs = function (_a) {
    var e_1, _b;
    var sendingToEmbrace = _a.sendingToEmbrace, appID = _a.appID, enduserPseudoID = _a.enduserPseudoID, resource = _a.resource, logExporters = _a.logExporters, logProcessors = _a.logProcessors, spanSessionManager = _a.spanSessionManager;
    var embraceLogManager = new EmbraceLogManager();
    log.setGlobalLogManager(embraceLogManager);
    var loggerProvider = new LoggerProvider({
        resource: resource,
    });
    var finalLogProcessors = __spreadArray(__spreadArray([], __read(logProcessors), false), [
        new IdentifiableSessionLogRecordProcessor({
            spanSessionManager: spanSessionManager,
        }),
        new EmbTypeLogRecordProcessor(),
    ], false);
    logExporters === null || logExporters === void 0 ? void 0 : logExporters.forEach(function (exporter) {
        finalLogProcessors.push(new BatchLogRecordProcessor(exporter));
    });
    if (sendingToEmbrace && appID && enduserPseudoID) {
        finalLogProcessors.push(new BatchLogRecordProcessor(new EmbraceLogExporter({
            appID: appID,
            userID: enduserPseudoID,
        })));
    }
    try {
        for (var finalLogProcessors_1 = __values(finalLogProcessors), finalLogProcessors_1_1 = finalLogProcessors_1.next(); !finalLogProcessors_1_1.done; finalLogProcessors_1_1 = finalLogProcessors_1.next()) {
            var logProcessor = finalLogProcessors_1_1.value;
            loggerProvider.addLogRecordProcessor(logProcessor);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (finalLogProcessors_1_1 && !finalLogProcessors_1_1.done && (_b = finalLogProcessors_1.return)) _b.call(finalLogProcessors_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    logs.setGlobalLoggerProvider(loggerProvider);
    return loggerProvider;
};
//# sourceMappingURL=initSDK.js.map