import { diag } from '@opentelemetry/api';
var Registry = /** @class */ (function () {
    function Registry(_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.diagLogger, diagLogger = _c === void 0 ? diag.createComponentLogger({ namespace: 'embrace-registry' }) : _c;
        var _this = this;
        this._sdk = null;
        this.register = function (sdk) {
            if (_this._sdk !== null) {
                _this._diag.warn('previously registered sdk will be overwritten');
            }
            _this._sdk = sdk;
        };
        this.clear = function () {
            if (_this._sdk === null) {
                _this._diag.warn('sdk already cleared, this is a no-op');
            }
            _this._sdk = null;
        };
        this.registered = function () {
            return _this._sdk;
        };
        this._diag = diagLogger;
    }
    return Registry;
}());
export var registry = new Registry();
//# sourceMappingURL=registry.js.map