var InMemoryStorage = /** @class */ (function () {
    function InMemoryStorage() {
        this._items = {};
    }
    Object.defineProperty(InMemoryStorage.prototype, "length", {
        get: function () {
            return Object.keys(this._items).length;
        },
        enumerable: false,
        configurable: true
    });
    InMemoryStorage.prototype.clear = function () {
        var _this = this;
        // eslint-disable-next-line @typescript-eslint/no-dynamic-delete
        Object.keys(this._items).forEach(function (key) { return delete _this._items[key]; });
    };
    InMemoryStorage.prototype.getItem = function (key) {
        return this._items[key];
    };
    InMemoryStorage.prototype.key = function (index) {
        return Object.keys(this._items)[index];
    };
    InMemoryStorage.prototype.removeItem = function (key) {
        // eslint-disable-next-line @typescript-eslint/no-dynamic-delete
        delete this._items[key];
    };
    InMemoryStorage.prototype.setItem = function (key, value) {
        this._items[key] = value;
    };
    return InMemoryStorage;
}());
export { InMemoryStorage };
//# sourceMappingURL=InMemoryStorage.js.map