import * as sinon from 'sinon';
// TODO this helper file could be open sourced as a separate package
var withRequest = function (arg) { return arg instanceof window.Request; };
export var getOptions = function () {
    return (window.fetch.firstCall.args[1] || {});
};
export var install = function () {
    sinon.stub(window, 'fetch');
};
export var restore = function () {
    window.fetch.restore();
};
export var getMethod = function () {
    var _a, _b;
    var firstArg = window.fetch.firstCall.args[0];
    if (withRequest(firstArg)) {
        return firstArg.method;
    }
    return (_b = (_a = getOptions()) === null || _a === void 0 ? void 0 : _a.method) !== null && _b !== void 0 ? _b : 'get';
};
export var getBody = function () {
    var _a, _b;
    var firstArg = window.fetch.firstCall.args[0];
    if (withRequest(firstArg)) {
        return firstArg.body;
    }
    return (_b = (_a = getOptions()) === null || _a === void 0 ? void 0 : _a.body) !== null && _b !== void 0 ? _b : '';
};
export var getUrl = function () {
    var firstArg = window.fetch.firstCall.args[0];
    if (withRequest(firstArg)) {
        return firstArg.url;
    }
    return firstArg;
};
export var getRequestHeaders = function () {
    var _a, _b;
    var firstArg = window.fetch.firstCall.args[0];
    if (withRequest(firstArg)) {
        return firstArg.headers;
    }
    return (_b = (_a = getOptions()) === null || _a === void 0 ? void 0 : _a.headers) !== null && _b !== void 0 ? _b : {};
};
export var respondWith = function (data, options) {
    return window.fetch.returns(Promise.resolve(new Response(data, options)));
};
export var wasCalled = function () { return !!window.fetch.firstCall; };
//# sourceMappingURL=index.js.map