var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { trace } from '@opentelemetry/api';
import { InMemorySpanExporter, SimpleSpanProcessor, WebTracerProvider, } from '@opentelemetry/sdk-trace-web';
/**
 * setupTestTraceExporter is a utility function that sets up a test trace exporter for use in testing.
 * It returns an instance of InMemorySpanExporter, hooked into a SimpleSpanProcessor, and a WebTracerProvider.
 * */
export var setupTestTraceExporter = function (spanProcessors) {
    if (spanProcessors === void 0) { spanProcessors = []; }
    var memoryExporter = new InMemorySpanExporter();
    var tracerProvider = new WebTracerProvider({
        spanProcessors: __spreadArray(__spreadArray([], __read(spanProcessors), false), [
            new SimpleSpanProcessor(memoryExporter),
        ], false),
    });
    trace.setGlobalTracerProvider(tracerProvider);
    return memoryExporter;
};
//# sourceMappingURL=setupTestTraceExporter.js.map