var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var FetchTransport = /** @class */ (function () {
    function FetchTransport(_config) {
        this._config = _config;
    }
    // _compressRequest compresses the data using the gzip algorithm.
    // Embrace Data endpoints require the data to be compressed.
    FetchTransport._compressRequest = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var stream, writer, compressedChunks, reader, done, result, compressedData, offset, compressedChunks_1, compressedChunks_1_1, chunk;
            var e_1, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        stream = new CompressionStream('gzip');
                        writer = stream.writable.getWriter();
                        void writer.write(data);
                        void writer.close();
                        compressedChunks = [];
                        reader = stream.readable.getReader();
                        done = false;
                        _b.label = 1;
                    case 1:
                        if (!!done) return [3 /*break*/, 3];
                        return [4 /*yield*/, reader.read()];
                    case 2:
                        result = _b.sent();
                        if (result.value) {
                            compressedChunks.push(result.value);
                        }
                        done = result.done;
                        return [3 /*break*/, 1];
                    case 3:
                        compressedData = new Uint8Array(compressedChunks.reduce(function (acc, chunk) { return acc + chunk.length; }, 0));
                        offset = 0;
                        try {
                            for (compressedChunks_1 = __values(compressedChunks), compressedChunks_1_1 = compressedChunks_1.next(); !compressedChunks_1_1.done; compressedChunks_1_1 = compressedChunks_1.next()) {
                                chunk = compressedChunks_1_1.value;
                                compressedData.set(chunk, offset);
                                offset += chunk.length;
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (compressedChunks_1_1 && !compressedChunks_1_1.done && (_a = compressedChunks_1.return)) _a.call(compressedChunks_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                        return [2 /*return*/, compressedData];
                }
            });
        });
    };
    FetchTransport.prototype.send = function (data, timeoutMillis) {
        return this._asyncSend(data, timeoutMillis);
    };
    FetchTransport.prototype.shutdown = function () {
        // Intentionally left empty, nothing to do.
    };
    FetchTransport.prototype._asyncSend = function (data, timeoutMillis) {
        return __awaiter(this, void 0, void 0, function () {
            var request, headers, response, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        request = data;
                        headers = __assign({ 'Content-Type': 'application/json' }, this._config.headers);
                        if (!(this._config.compression === 'gzip')) return [3 /*break*/, 2];
                        return [4 /*yield*/, FetchTransport._compressRequest(data)];
                    case 1:
                        request = _b.sent();
                        headers['Content-Encoding'] = 'gzip';
                        headers['Content-Length'] = request.length.toString();
                        _b.label = 2;
                    case 2:
                        _b.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, fetch(this._config.url, {
                                method: 'POST',
                                keepalive: true,
                                headers: headers,
                                body: request,
                                signal: AbortSignal.timeout(timeoutMillis),
                            })];
                    case 3:
                        response = _b.sent();
                        if (response.ok) {
                            return [2 /*return*/, { status: 'success' }];
                        }
                        else {
                            return [2 /*return*/, { status: 'failure', error: new Error('Fetch request failed') }];
                        }
                        return [3 /*break*/, 5];
                    case 4:
                        _a = _b.sent();
                        return [2 /*return*/, { status: 'failure', error: new Error('Fetch request errored') }];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    return FetchTransport;
}());
export { FetchTransport };
//# sourceMappingURL=FetchTransport.js.map