import { millisToHrTime, otperformance } from '@opentelemetry/core';
var OTelPerformanceManager = /** @class */ (function () {
    function OTelPerformanceManager(clock) {
        if (clock === void 0) { clock = otperformance; }
        var _this = this;
        this.epochMillisFromOriginOffset = function (originOffset) {
            return _this._clock.timeOrigin + originOffset;
        };
        this.getNowHRTime = function () { return millisToHrTime(_this.getNowMillis()); };
        this.getNowMillis = function () {
            return _this.epochMillisFromOriginOffset(_this._clock.now());
        }; // otperformance.now() returns milliseconds since timeOrigin, timeOrigin is the time from epoch to the start of the page load
        this._clock = clock;
    }
    return OTelPerformanceManager;
}());
export { OTelPerformanceManager };
//# sourceMappingURL=OTelPerformanceManager.js.map