/**
 * Add multiple event listeners to a target element.
 * example:
 *
 * ```
 * bulkAddEventListener({
 *  target: window,
 *  events: ['visibilitychange', 'resize'],
 *  callback: () => console.log('Event fired'),
 *  });
 *```
 * */
export var bulkAddEventListener = function (_a) {
    var target = _a.target, events = _a.events, callback = _a.callback;
    events.forEach(function (event) {
        target.addEventListener(event, callback);
    });
};
//# sourceMappingURL=bulkAddEventListener.js.map