/**
 * Remove multiple event listeners from a target element.
 * example:
 *
 * ```
 * bulkRemoveEventListener({
 *  target: window,
 *  events: ['visibilitychange', 'resize'],
 *  callback: someRefToACallbackFunction,
 *  });
 *```
 * */
export var bulkRemoveEventListener = function (_a) {
    var target = _a.target, events = _a.events, callback = _a.callback;
    events.forEach(function (event) {
        target.removeEventListener(event, callback);
    });
};
//# sourceMappingURL=bulkRemoveEventListener.js.map