var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
/**
 * Wraps a callback in a try-catch and returns a default value upon failure
 */
export var withErrorFallback = function (fn, defaultValue, silent, diag) {
    if (silent === void 0) { silent = true; }
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        try {
            return fn.apply(void 0, __spreadArray([], __read(args), false));
        }
        catch (e) {
            if (!silent) {
                if (diag) {
                    var message = e instanceof Error ? e.message : 'Unknown error.';
                    diag.error(message);
                }
                else {
                    console.error(e);
                }
            }
            return defaultValue;
        }
    };
};
//# sourceMappingURL=withErrorFallback.js.map