import { ProxyLogManager } from '../../manager/index.js';
export class LogAPI {
    constructor({ proxyLogManager }) {
        this.getLogManager = () => {
            return this._proxyLogManager;
        };
        this._proxyLogManager = proxyLogManager;
    }
    static getInstance() {
        if (!this._instance) {
            this._instance = new LogAPI({
                proxyLogManager: new ProxyLogManager(),
            });
        }
        return this._instance;
    }
    setGlobalLogManager(logManager) {
        this._proxyLogManager.setDelegate(logManager);
    }
    logException(error, handled, attributes, timestamp) {
        this.getLogManager().logException(error, handled, attributes, timestamp);
    }
    message(message, level, attributes, includeStacktrace) {
        this.getLogManager().message(message, level, attributes, includeStacktrace);
    }
}
//# sourceMappingURL=LogAPI.js.map