import { ProxyTraceManager } from '../../manager/index.js';
export class TraceAPI {
    constructor({ proxyTraceManager }) {
        this.getTraceManager = () => {
            return this._proxyTraceManager;
        };
        this._proxyTraceManager = proxyTraceManager;
    }
    static getInstance() {
        if (!this._instance) {
            this._instance = new TraceAPI({
                proxyTraceManager: new ProxyTraceManager(),
            });
        }
        return this._instance;
    }
    setGlobalTraceManager(traceManager) {
        this._proxyTraceManager.setDelegate(traceManager);
    }
    startPerformanceSpan(name, options) {
        return this.getTraceManager().startPerformanceSpan(name, options);
    }
}
//# sourceMappingURL=TraceAPI.js.map