import { ProxyUserManager } from '../../manager/index.js';
export class UserAPI {
    constructor({ proxyUserManager }) {
        this._proxyUserManager = proxyUserManager;
    }
    static getInstance() {
        if (!this._instance) {
            this._instance = new UserAPI({
                proxyUserManager: new ProxyUserManager(),
            });
        }
        return this._instance;
    }
    getUserManager() {
        return this._proxyUserManager;
    }
    setGlobalUserManager(userManager) {
        this._proxyUserManager.setDelegate(userManager);
    }
    clearUser() {
        this.getUserManager().clearUser();
    }
    getUser() {
        return this.getUserManager().getUser();
    }
    setUser(user) {
        this.getUserManager().setUser(user);
    }
}
//# sourceMappingURL=UserAPI.js.map