import { session } from '../../api-sessions/index.js';
import { log } from '../../api-logs/index.js';
import { OTelPerformanceManager } from '../../utils/index.js';
import { InstrumentationAbstract } from '../InstrumentationAbstract/index.js';
export class EmbraceInstrumentationBase extends InstrumentationAbstract {
    constructor({ instrumentationName, instrumentationVersion, config, diag, perf, }) {
        super(instrumentationName, instrumentationVersion, config);
        // optionally override the diag logger from the base class
        if (diag) {
            this._diag = diag;
        }
        this._perf = perf !== null && perf !== void 0 ? perf : new OTelPerformanceManager();
        this._sessionManager = session.getSpanSessionManager();
        this._logManager = log.getLogManager();
    }
    /* Returns session provider */
    get sessionManager() {
        return this._sessionManager;
    }
    /* Returns session provider */
    get logManager() {
        return this._logManager;
    }
    /* Returns the performance manager */
    get perf() {
        return this._perf;
    }
    // no-op
    init() {
        return undefined;
    }
}
//# sourceMappingURL=EmbraceInstrumentationBase.js.map