import { type DiagLogger, type Span } from '@opentelemetry/api';
import type { ReadableSpan, SpanProcessor } from '@opentelemetry/sdk-trace-web';
import type { EmbraceProcessorArgs } from './types.js';
export declare abstract class EmbraceProcessor implements SpanProcessor {
    private readonly _diag;
    private readonly _processorName;
    protected constructor({ diag: providedDiag, processorName, }: EmbraceProcessorArgs);
    protected get diag(): DiagLogger;
    protected get processorName(): string;
    abstract forceFlush(): Promise<void>;
    abstract onEnd(span: ReadableSpan): void;
    abstract onStart(span: Span): void;
    abstract shutdown(): Promise<void>;
}
//# sourceMappingURL=EmbraceProcessor.d.ts.map