import { diag } from '@opentelemetry/api';
export class EmbraceProcessor {
    constructor({ diag: providedDiag, processorName, }) {
        this._processorName = processorName;
        this._diag =
            providedDiag !== null && providedDiag !== void 0 ? providedDiag : diag.createComponentLogger({
                namespace: processorName,
            });
    }
    /* Returns the diag logger */
    get diag() {
        return this._diag;
    }
    /* Returns the processor name */
    get processorName() {
        return this._processorName;
    }
}
//# sourceMappingURL=EmbraceProcessor.js.map