import { diag } from '@opentelemetry/api';
class Registry {
    constructor({ diagLogger = diag.createComponentLogger({ namespace: 'embrace-registry' }), } = {}) {
        this._sdk = null;
        this.register = sdk => {
            if (this._sdk !== null) {
                this._diag.warn('previously registered sdk will be overwritten');
            }
            this._sdk = sdk;
        };
        this.clear = () => {
            if (this._sdk === null) {
                this._diag.warn('sdk already cleared, this is a no-op');
            }
            this._sdk = null;
        };
        this.registered = () => {
            return this._sdk;
        };
        this._diag = diagLogger;
    }
}
export const registry = new Registry();
//# sourceMappingURL=registry.js.map