import { EmbraceInstrumentationBase } from '../../instrumentations/index.js';
export class FakeInstrumentation extends EmbraceInstrumentationBase {
    constructor() {
        super({
            instrumentationName: 'FakeInstrumentation',
            instrumentationVersion: '1.0.0',
            config: {},
        });
        this._enabled = false;
        if (this._config.enabled) {
            this.enable();
        }
    }
    disable() {
        this._enabled = false;
    }
    enable() {
        this._enabled = true;
    }
    emit() {
        if (this._enabled) {
            this.logger.emit({
                body: 'my log',
            });
            this.tracer.startSpan('my span').end();
        }
    }
}
//# sourceMappingURL=FakeInstrumentation.js.map