import * as sinon from 'sinon';
// TODO this helper file could be open sourced as a separate package
const withRequest = (arg) => arg instanceof window.Request;
export const getOptions = () => (window.fetch.firstCall.args[1] || {});
export const install = () => {
    sinon.stub(window, 'fetch');
};
export const restore = () => {
    window.fetch.restore();
};
export const getMethod = () => {
    var _a, _b;
    const firstArg = window.fetch.firstCall.args[0];
    if (withRequest(firstArg)) {
        return firstArg.method;
    }
    return (_b = (_a = getOptions()) === null || _a === void 0 ? void 0 : _a.method) !== null && _b !== void 0 ? _b : 'get';
};
export const getBody = () => {
    var _a, _b;
    const firstArg = window.fetch.firstCall.args[0];
    if (withRequest(firstArg)) {
        return firstArg.body;
    }
    return (_b = (_a = getOptions()) === null || _a === void 0 ? void 0 : _a.body) !== null && _b !== void 0 ? _b : '';
};
export const getUrl = () => {
    const firstArg = window.fetch.firstCall.args[0];
    if (withRequest(firstArg)) {
        return firstArg.url;
    }
    return firstArg;
};
export const getRequestHeaders = () => {
    var _a, _b;
    const firstArg = window.fetch.firstCall.args[0];
    if (withRequest(firstArg)) {
        return firstArg.headers;
    }
    return (_b = (_a = getOptions()) === null || _a === void 0 ? void 0 : _a.headers) !== null && _b !== void 0 ? _b : {};
};
export const respondWith = (data, options) => window.fetch.returns(Promise.resolve(new Response(data, options)));
export const wasCalled = () => !!window.fetch.firstCall;
//# sourceMappingURL=index.js.map