import { millisToHrTime, otperformance } from '@opentelemetry/core';
export class OTelPerformanceManager {
    constructor(clock = otperformance) {
        this.epochMillisFromOriginOffset = (originOffset) => this._clock.timeOrigin + originOffset;
        this.getNowHRTime = () => millisToHrTime(this.getNowMillis());
        this.getNowMillis = () => this.epochMillisFromOriginOffset(this._clock.now()); // otperformance.now() returns milliseconds since timeOrigin, timeOrigin is the time from epoch to the start of the page load
        this._clock = clock;
    }
}
//# sourceMappingURL=OTelPerformanceManager.js.map