"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogAPI = void 0;
const index_js_1 = require("../../manager/index.js");
class LogAPI {
    constructor({ proxyLogManager }) {
        this.getLogManager = () => {
            return this._proxyLogManager;
        };
        this._proxyLogManager = proxyLogManager;
    }
    static getInstance() {
        if (!this._instance) {
            this._instance = new LogAPI({
                proxyLogManager: new index_js_1.ProxyLogManager(),
            });
        }
        return this._instance;
    }
    setGlobalLogManager(logManager) {
        this._proxyLogManager.setDelegate(logManager);
    }
    logException(error, handled, attributes, timestamp) {
        this.getLogManager().logException(error, handled, attributes, timestamp);
    }
    message(message, level, attributes, includeStacktrace) {
        this.getLogManager().message(message, level, attributes, includeStacktrace);
    }
}
exports.LogAPI = LogAPI;
//# sourceMappingURL=LogAPI.js.map