"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SessionAPI = void 0;
const index_js_1 = require("../../manager/index.js");
class SessionAPI {
    constructor({ proxySpanSessionManager }) {
        this.getSpanSessionManager = () => {
            return this._proxySpanSessionManager;
        };
        this._proxySpanSessionManager = proxySpanSessionManager;
    }
    static getInstance() {
        if (!this._instance) {
            this._instance = new SessionAPI({
                proxySpanSessionManager: new index_js_1.ProxySpanSessionManager(),
            });
        }
        return this._instance;
    }
    setGlobalSessionManager(sessionManager) {
        this._proxySpanSessionManager.setDelegate(sessionManager);
    }
    addBreadcrumb(name) {
        this.getSpanSessionManager().addBreadcrumb(name);
    }
    addProperty(key, value) {
        this.getSpanSessionManager().addProperty(key, value);
    }
    endSessionSpan() {
        this.getSpanSessionManager().endSessionSpan();
    }
    endSessionSpanInternal(reason) {
        this.getSpanSessionManager().endSessionSpanInternal(reason);
    }
    getSessionId() {
        return this.getSpanSessionManager().getSessionId();
    }
    getSessionSpan() {
        return this.getSpanSessionManager().getSessionSpan();
    }
    getSessionStartTime() {
        return this.getSpanSessionManager().getSessionStartTime();
    }
    startSessionSpan() {
        this.getSpanSessionManager().startSessionSpan();
    }
}
exports.SessionAPI = SessionAPI;
//# sourceMappingURL=SessionAPI.js.map