"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TraceAPI = void 0;
const index_js_1 = require("../../manager/index.js");
class TraceAPI {
    constructor({ proxyTraceManager }) {
        this.getTraceManager = () => {
            return this._proxyTraceManager;
        };
        this._proxyTraceManager = proxyTraceManager;
    }
    static getInstance() {
        if (!this._instance) {
            this._instance = new TraceAPI({
                proxyTraceManager: new index_js_1.ProxyTraceManager(),
            });
        }
        return this._instance;
    }
    setGlobalTraceManager(traceManager) {
        this._proxyTraceManager.setDelegate(traceManager);
    }
    startPerformanceSpan(name, options) {
        return this.getTraceManager().startPerformanceSpan(name, options);
    }
}
exports.TraceAPI = TraceAPI;
//# sourceMappingURL=TraceAPI.js.map