"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserAPI = void 0;
const index_js_1 = require("../../manager/index.js");
class UserAPI {
    constructor({ proxyUserManager }) {
        this._proxyUserManager = proxyUserManager;
    }
    static getInstance() {
        if (!this._instance) {
            this._instance = new UserAPI({
                proxyUserManager: new index_js_1.ProxyUserManager(),
            });
        }
        return this._instance;
    }
    getUserManager() {
        return this._proxyUserManager;
    }
    setGlobalUserManager(userManager) {
        this._proxyUserManager.setDelegate(userManager);
    }
    clearUser() {
        this.getUserManager().clearUser();
    }
    getUser() {
        return this.getUserManager().getUser();
    }
    setUser(user) {
        this.getUserManager().setUser(user);
    }
}
exports.UserAPI = UserAPI;
//# sourceMappingURL=UserAPI.js.map