"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createOtlpBrowserFetchExportDelegate = void 0;
const otlp_exporter_base_1 = require("@opentelemetry/otlp-exporter-base");
const index_js_1 = require("../transport/index.js");
// createOtlpBrowserFetchExportDelegate creates an export delegate that uses
// the Fetch API to send data to an OTLP receiver.
const createOtlpBrowserFetchExportDelegate = (config, serializer) => 
// createOtlpNetworkExportDelegate has an internal queue that handles
// multiple requests going at the same time.
(0, otlp_exporter_base_1.createOtlpNetworkExportDelegate)(config, serializer, (0, index_js_1.createRetryingTransport)({
    transport: (0, index_js_1.createFetchTransport)(config),
}));
exports.createOtlpBrowserFetchExportDelegate = createOtlpBrowserFetchExportDelegate;
//# sourceMappingURL=otlpBrowserFetchExportDelegate.js.map