"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EmbraceInstrumentationBase = void 0;
const index_js_1 = require("../../api-sessions/index.js");
const index_js_2 = require("../../api-logs/index.js");
const index_js_3 = require("../../utils/index.js");
const index_js_4 = require("../InstrumentationAbstract/index.js");
class EmbraceInstrumentationBase extends index_js_4.InstrumentationAbstract {
    constructor({ instrumentationName, instrumentationVersion, config, diag, perf, }) {
        super(instrumentationName, instrumentationVersion, config);
        // optionally override the diag logger from the base class
        if (diag) {
            this._diag = diag;
        }
        this._perf = perf !== null && perf !== void 0 ? perf : new index_js_3.OTelPerformanceManager();
        this._sessionManager = index_js_1.session.getSpanSessionManager();
        this._logManager = index_js_2.log.getLogManager();
    }
    /* Returns session provider */
    get sessionManager() {
        return this._sessionManager;
    }
    /* Returns session provider */
    get logManager() {
        return this._logManager;
    }
    /* Returns the performance manager */
    get perf() {
        return this._perf;
    }
    // no-op
    init() {
        return undefined;
    }
}
exports.EmbraceInstrumentationBase = EmbraceInstrumentationBase;
//# sourceMappingURL=EmbraceInstrumentationBase.js.map