"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getHTMLElementFriendlyName = void 0;
const MAX_INNER_TEXT = 30;
const getHTMLElementFriendlyName = (element) => {
    const nodeName = element.nodeName.toLowerCase();
    const innerText = element.innerText.substring(0, MAX_INNER_TEXT);
    const ellipsis = element.innerText.length > MAX_INNER_TEXT ? '...' : '';
    const className = element.className ? ` class="${element.className}"` : '';
    return `<${nodeName}${className}>${innerText}${ellipsis}</${nodeName}>`;
};
exports.getHTMLElementFriendlyName = getHTMLElementFriendlyName;
//# sourceMappingURL=utils.js.map