"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SpanSessionVisibilityInstrumentation = void 0;
const index_js_1 = require("../../EmbraceInstrumentationBase/index.js");
class SpanSessionVisibilityInstrumentation extends index_js_1.EmbraceInstrumentationBase {
    constructor({ diag } = {}) {
        super({
            instrumentationName: 'SpanSessionOnLoadInstrumentation',
            instrumentationVersion: '1.0.0',
            config: {},
            diag,
        });
        this._onVisibilityChange = () => {
            if (document.visibilityState === 'hidden') {
                this._diag.debug('Visibility change detected: hidden');
                this.sessionManager.endSessionSpanInternal('bkgnd_state');
            }
            else {
                this._diag.debug('Visibility change detected: visible');
                this.sessionManager.startSessionSpan();
            }
        };
        if (this._config.enabled) {
            this.enable();
        }
    }
    disable() {
        window.removeEventListener('visibilitychange', this._onVisibilityChange);
    }
    enable() {
        window.addEventListener('visibilitychange', this._onVisibilityChange);
    }
}
exports.SpanSessionVisibilityInstrumentation = SpanSessionVisibilityInstrumentation;
//# sourceMappingURL=SpanSessionVisibilityInstrumentation.js.map