"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isNetworkSpan = void 0;
const semantic_conventions_1 = require("@opentelemetry/semantic-conventions");
const SCHEME_RE = /.+:\/\/.+/;
const isNetworkSpan = (span) => {
    var _a;
    if ((span.attributes[semantic_conventions_1.ATTR_HTTP_REQUEST_METHOD] || // eslint-disable-next-line @typescript-eslint/no-deprecated
        span.attributes[semantic_conventions_1.SEMATTRS_HTTP_METHOD]) &&
        (span.attributes[semantic_conventions_1.ATTR_HTTP_RESPONSE_STATUS_CODE] || // eslint-disable-next-line @typescript-eslint/no-deprecated
            span.attributes[semantic_conventions_1.SEMATTRS_HTTP_STATUS_CODE])) {
        const url = // eslint-disable-next-line @typescript-eslint/no-deprecated
         (_a = span.attributes[semantic_conventions_1.ATTR_URL_FULL]) !== null && _a !== void 0 ? _a : span.attributes[semantic_conventions_1.SEMATTRS_HTTP_URL];
        return !!(url && typeof url === 'string' && SCHEME_RE.exec(url));
    }
    return false;
};
exports.isNetworkSpan = isNetworkSpan;
// not used yet, but added for clarity. This is the type for Embrace tagged network spans
// interface EmbraceNetworkSpanAttributes extends Attributes {
//   [KEY_EMB_TYPE]: EMB_TYPES.Network;
// }
// interface EmbraceNetworkSpan extends NetworkSpan {
//   attributes: NetworkSpanAttributes & EmbraceNetworkSpanAttributes;
// }
//# sourceMappingURL=types.js.map