"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EmbraceProcessor = void 0;
const api_1 = require("@opentelemetry/api");
class EmbraceProcessor {
    constructor({ diag: providedDiag, processorName, }) {
        this._processorName = processorName;
        this._diag =
            providedDiag !== null && providedDiag !== void 0 ? providedDiag : api_1.diag.createComponentLogger({
                namespace: processorName,
            });
    }
    /* Returns the diag logger */
    get diag() {
        return this._diag;
    }
    /* Returns the processor name */
    get processorName() {
        return this._processorName;
    }
}
exports.EmbraceProcessor = EmbraceProcessor;
//# sourceMappingURL=EmbraceProcessor.js.map