"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FakeInstrumentation = void 0;
const index_js_1 = require("../../instrumentations/index.js");
class FakeInstrumentation extends index_js_1.EmbraceInstrumentationBase {
    constructor() {
        super({
            instrumentationName: 'FakeInstrumentation',
            instrumentationVersion: '1.0.0',
            config: {},
        });
        this._enabled = false;
        if (this._config.enabled) {
            this.enable();
        }
    }
    disable() {
        this._enabled = false;
    }
    enable() {
        this._enabled = true;
    }
    emit() {
        if (this._enabled) {
            this.logger.emit({
                body: 'my log',
            });
            this.tracer.startSpan('my span').end();
        }
    }
}
exports.FakeInstrumentation = FakeInstrumentation;
//# sourceMappingURL=FakeInstrumentation.js.map