"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InMemoryStorage = void 0;
class InMemoryStorage {
    constructor() {
        this._items = {};
    }
    get length() {
        return Object.keys(this._items).length;
    }
    clear() {
        // eslint-disable-next-line @typescript-eslint/no-dynamic-delete
        Object.keys(this._items).forEach(key => delete this._items[key]);
    }
    getItem(key) {
        return this._items[key];
    }
    key(index) {
        return Object.keys(this._items)[index];
    }
    removeItem(key) {
        // eslint-disable-next-line @typescript-eslint/no-dynamic-delete
        delete this._items[key];
    }
    setItem(key, value) {
        this._items[key] = value;
    }
}
exports.InMemoryStorage = InMemoryStorage;
//# sourceMappingURL=InMemoryStorage.js.map