"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MockPerformanceManager = void 0;
const index_js_1 = require("../../utils/index.js");
class MockPerformanceManager extends index_js_1.OTelPerformanceManager {
    constructor(clock) {
        super({
            now: () => clock.now,
            // For real performance timing `timeOrigin` is the timestamp when the document's lifetime started: https://developer.mozilla.org/en-US/docs/Web/API/Performance/timeOrigin#value
            // When mocking set it to whatever value our fake clock had at the time that this MockPerformanceManager was instantiated
            timeOrigin: clock.now,
        });
    }
}
exports.MockPerformanceManager = MockPerformanceManager;
//# sourceMappingURL=MockPerformanceManager.js.map