"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.wasCalled = exports.respondWith = exports.getRequestHeaders = exports.getUrl = exports.getBody = exports.getMethod = exports.restore = exports.install = exports.getOptions = void 0;
const sinon = require("sinon");
// TODO this helper file could be open sourced as a separate package
const withRequest = (arg) => arg instanceof window.Request;
const getOptions = () => (window.fetch.firstCall.args[1] || {});
exports.getOptions = getOptions;
const install = () => {
    sinon.stub(window, 'fetch');
};
exports.install = install;
const restore = () => {
    window.fetch.restore();
};
exports.restore = restore;
const getMethod = () => {
    var _a, _b;
    const firstArg = window.fetch.firstCall.args[0];
    if (withRequest(firstArg)) {
        return firstArg.method;
    }
    return (_b = (_a = (0, exports.getOptions)()) === null || _a === void 0 ? void 0 : _a.method) !== null && _b !== void 0 ? _b : 'get';
};
exports.getMethod = getMethod;
const getBody = () => {
    var _a, _b;
    const firstArg = window.fetch.firstCall.args[0];
    if (withRequest(firstArg)) {
        return firstArg.body;
    }
    return (_b = (_a = (0, exports.getOptions)()) === null || _a === void 0 ? void 0 : _a.body) !== null && _b !== void 0 ? _b : '';
};
exports.getBody = getBody;
const getUrl = () => {
    const firstArg = window.fetch.firstCall.args[0];
    if (withRequest(firstArg)) {
        return firstArg.url;
    }
    return firstArg;
};
exports.getUrl = getUrl;
const getRequestHeaders = () => {
    var _a, _b;
    const firstArg = window.fetch.firstCall.args[0];
    if (withRequest(firstArg)) {
        return firstArg.headers;
    }
    return (_b = (_a = (0, exports.getOptions)()) === null || _a === void 0 ? void 0 : _a.headers) !== null && _b !== void 0 ? _b : {};
};
exports.getRequestHeaders = getRequestHeaders;
const respondWith = (data, options) => window.fetch.returns(Promise.resolve(new Response(data, options)));
exports.respondWith = respondWith;
const wasCalled = () => !!window.fetch.firstCall;
exports.wasCalled = wasCalled;
//# sourceMappingURL=index.js.map