"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OTelPerformanceManager = void 0;
const core_1 = require("@opentelemetry/core");
class OTelPerformanceManager {
    constructor(clock = core_1.otperformance) {
        this.epochMillisFromOriginOffset = (originOffset) => this._clock.timeOrigin + originOffset;
        this.getNowHRTime = () => (0, core_1.millisToHrTime)(this.getNowMillis());
        this.getNowMillis = () => this.epochMillisFromOriginOffset(this._clock.now()); // otperformance.now() returns milliseconds since timeOrigin, timeOrigin is the time from epoch to the start of the page load
        this._clock = clock;
    }
}
exports.OTelPerformanceManager = OTelPerformanceManager;
//# sourceMappingURL=OTelPerformanceManager.js.map