"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bulkAddEventListener = void 0;
/**
 * Add multiple event listeners to a target element.
 * example:
 *
 * ```
 * bulkAddEventListener({
 *  target: window,
 *  events: ['visibilitychange', 'resize'],
 *  callback: () => console.log('Event fired'),
 *  });
 *```
 * */
const bulkAddEventListener = ({ target, events, callback, }) => {
    events.forEach(event => {
        target.addEventListener(event, callback);
    });
};
exports.bulkAddEventListener = bulkAddEventListener;
//# sourceMappingURL=bulkAddEventListener.js.map