"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bulkRemoveEventListener = void 0;
/**
 * Remove multiple event listeners from a target element.
 * example:
 *
 * ```
 * bulkRemoveEventListener({
 *  target: window,
 *  events: ['visibilitychange', 'resize'],
 *  callback: someRefToACallbackFunction,
 *  });
 *```
 * */
const bulkRemoveEventListener = ({ target, events, callback, }) => {
    events.forEach(event => {
        target.removeEventListener(event, callback);
    });
};
exports.bulkRemoveEventListener = bulkRemoveEventListener;
//# sourceMappingURL=bulkRemoveEventListener.js.map